package moe.tristan.easyfxml.model.awt.integrations;

import java.net.URL;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import moe.tristan.easyfxml.model.awt.HeadlessIncompatibleTest;
import moe.tristan.easyfxml.spring.SpringContext;

@ContextConfiguration(classes = SpringContext.class)
@RunWith(SpringJUnit4ClassRunner.class)
public class BrowserSupportTest extends HeadlessIncompatibleTest {

    @Autowired
    private BrowserSupport browserSupport;

    @Test
    public void openUrl_good_url() {
        browserSupport.openUrl("https://www.google.fr");
    }

    @Test
    public void openUrl_bad_url() {
        browserSupport.openUrl("not_a_url");
    }

    @Test
    public void browse_ioe() {
        browserSupport.openUrl((URL) null);
    }

}
